#include <math.h>
#include <stdlib.h>
#include <stdio.h>
 
#include "greedy.h"

#define L_i_m1(i_) 	(max(Lr[i_]-1, J1))
#define R_ip1(i_) 	((i_==I2) ? J2 : Rr[(i_)+1])
#define milieu(i_)	((L_i_m1(i_) + R_ip1(i_) + 1) / 2)
#define m_im1(i_) 	((i_==I1) ? J1 : milieu((i_)-1))
#define L_ip1_m1(i_) 	((i_==I2) ? J2 : L_i_m1((i_)+1))
#define point_de_partition(i_, j_) ((j_ <= milieu(i_)) ? (j_ >= max(L_i_m1(i_), m_im1(i_))) : (j_ <= min(L_ip1_m1(i_), R_ip1(i_))))

#define azero(element)	element.b = element.h = 0;
#define aumax(element)	element.b = element.h = DISTANCE_ALIG_MAX.h;
#define affecter(element1, element2)	{ element1.b = element2.b; element1.h = element2.h; }
#define different(element1, element2)	(element1.b != element2.b || element1.h != element2.h)
#define sinferieur(element1, element2)	(element1.h < element2.h || \
					(element1.h == element2.h && element1.b < element2.b))
#define inferieuregal(element1, element2)	(element1.h < element2.h || \
					(element1.h == element2.h && element1.b <= element2.b))
#define ajouter(resultat, objet, pscore)	\
{	\
resultat.b = objet.b + pscore;	\
resultat.h = objet.h; \
if (pscore >= 0)	\
     {	\
	if (objet.b >= 0 && resultat.b < 0)	\
	     {	\
		resultat.b -= DISTANCE_ALIG_MAX.b;	\
		resultat.h++;	\
	     }	\
     }	\
else {	\
	if (objet.b < 0 && resultat.b >= 0)	\
	     {	\
		resultat.b += DISTANCE_ALIG_MAX.b;	\
		resultat.h--;	\
	     }	\
     }	\
}	\

#define CALCUL_INSERTION \
{	\
if (!pas_d_insertion || i == seq[0].longueur || i == 0)	\
     {	\
	if (different(e, DISTANCE_ALIG_MAX))	\
	    {	\
		scol = qngsm(i, j, histoire_e, n1, n2, INSE);	\
		ajouter(insert, e, scol)	\
	    }	\
	else	aumax(insert)	\
	if (d_egal_e) 	affecter(insert_deb, insert)	\
	else {	\
		if (different(d[j-1], DISTANCE_ALIG_MAX))	\
		    {	\
			scol = qngsm(i, j, histoire_d[j-1], n1, n2, INSE);	\
			ajouter(insert_deb, d[j-1], scol)	\
		    }	\
		else	aumax(insert_deb) \
	     }	\
     }	\
else {	\
		aumax(insert_deb); aumax(insert);	\
     }	\
if (sinferieur(insert_deb, insert))	\
	     {	\
		if (!RECURSIF)	ch[i][j] |= F_INS;	\
		affecter(insert, insert_deb)	\
		histoire_e = INSE;	\
		if (point_de_partition(i, j))	\
		     {	\
			succ_pp[diag][INSE] 	= pp[j-1][REMP];	\
			succ_tpp[diag][INSE] 	= tpp[j-1][REMP];	\
			histoire_pp_inse[diag] = histoire_e;	\
			pp_i[diag] 	= i;	\
			pp_ins 		= diag;	\
			tpp_ins 	= INSE;	\
		     }	\
		else {	\
			pp_ins 		= pp[j-1][REMP];	\
			tpp_ins 	= tpp[j-1][REMP];	\
		     }	\
	     }	\
else	     {	\
		histoire_e = INSE;	\
		if (point_de_partition(i, j))	\
		     {	\
			succ_pp[diag][INSE] 	= pp_ins;	\
			succ_tpp[diag][INSE] 	= tpp_ins;	\
			histoire_pp_inse[diag] = histoire_e;	\
			pp_i[diag] 	= i;	\
			pp_ins 		= diag;	\
			tpp_ins 	= INSE;	\
		     }	\
	     }	\
affecter(e, insert)	\
}

#define CALCUL_SUPPRESSION	\
{	\
if (!pas_de_suppression || j == seq[0].longueur || j == 0)	\
     {	\
	if (different(f[j], DISTANCE_ALIG_MAX))	\
	    {	\
		scol = qngsm(i, j, histoire_f[j], n1, n2, SUPP);	\
		ajouter(suppres, f[j], scol)	\
	    }	\
	else	aumax(suppres);	\
	if (different(d[j], DISTANCE_ALIG_MAX))	\
	    {	\
		scol = qngsm(i, j, histoire_d[j], n1, n2, SUPP);	\
		ajouter(suppres_deb, d[j], scol)	\
	    }	\
	else	aumax(suppres_deb)	\
     }	\
else {	\
		aumax(suppres_deb); aumax(suppres);	\
     }	\
if (sinferieur(suppres_deb, suppres))	\
	     {	\
		if (!RECURSIF)	ch[i][j] |= F_SUP;	\
		affecter(suppres, suppres_deb)	\
		histoire_f[j] = SUPP;	\
		if (point_de_partition(i, j))	\
		     {	\
			succ_pp[diag][SUPP] 	= pp[j][REMP];	\
			succ_tpp[diag][SUPP] 	= tpp[j][REMP];	\
			histoire_pp_supp[diag] = histoire_f[j];	\
			pp_i[diag] 	= i;	\
			pp[j][SUPP]	= diag;	\
			tpp[j][SUPP] 	= SUPP;	\
		     }	\
		else {	\
			pp[j][SUPP] 	= pp[j][REMP];	\
			tpp[j][SUPP] 	= tpp[j][REMP];	\
		     }	\
	     }	\
else	     {	\
		histoire_f[j] = SUPP;	\
		if (point_de_partition(i, j))	\
		     {	\
			succ_pp[diag][SUPP] 	= pp[j][SUPP];	\
			succ_tpp[diag][SUPP] 	= tpp[j][SUPP];	\
			histoire_pp_supp[diag] = histoire_f[j];	\
			pp_i[diag] 	= i;	\
			pp[j][SUPP] 	= diag;	\
			tpp[j][SUPP] 	= SUPP;	\
		     }	\
	     }	\
affecter(f[j], suppres)	\
}

#define SUPPRESSION(i_)		{ l++; alignement[l].i = i_; alignement[l].j = 0;}
#define INSERTION(j_)		{ l++; alignement[l].i = 0; alignement[l].j = j_;}
#define REMPLACEMENT(i_,j_)	{ l++; alignement[l].i = i_; alignement[l].j = j_;}

score qngsm(indice i, indice j, char histoire, noeud *n1, noeud *n2, char action);
void generer_gaps(noeud *base, lettre *colonne, int *s);
void generer_inconnus(noeud *base, lettre *colonne, int *s);
void generer_colonne_rec(noeud *base, indice i, lettre *colonne, int *s, int *nbl);
void generer_colonne(noeud *base, indice i, lettre *colonne, lettre *colonne_p);
int nbre_seq(noeud *base, int s, int *num_seq);
indice lire_alignement(indice i, indice j, frag *alignement);
indice aligne_2noeuds_non_rec(frag *alignement, indice l, noeud *n1, noeud *n2, 
	indice I1, indice J1, char Type1, indice I2, indice J2, char Type2);
indice aligne_2noeuds_rec(frag *alignement, indice l, noeud *n1, noeud *n2, 
	indice I1, indice J1, char Type1, indice I2, indice J2, char Type2);
void aligne_2noeuds(noeud *n0, noeud *n1, noeud *n2, int *poids_, int poids_max_);


extern sequence *seq;
extern int NBRE_LETTRES, X, INCONNU;
extern score alphaD, betaD;
extern echelle *ech;
extern indice **seuil_g, **seuil_d;

extern int NBRE_LETTRES,  R;
extern score **dis;

extern lettre *coli, *colj, *colip, *coljp, *colg;
extern int *num_seq1, *num_seq2;
extern int  nbseq1, nbseq2, nbseq;

extern gscore *d, *f;
extern gscore DISTANCE_ALIG_MAX;

extern char *histoire_d, *histoire_f, histoire_e;
extern char histoire_d_ip_jp, histoire_d_sauv;
extern char *histoire_pp_remp, *histoire_pp_supp, *histoire_pp_inse;

extern int (*pp)[2], (*succ_pp)[3], *pp_i, *Rr, *Lr;
extern char (*tpp)[2], (*succ_tpp)[3], *contrainte;

extern char **ch;
extern score **dist_entre_seq;
extern char RECURSIF;
extern char decode[100];
extern lettre code[128];

extern char COMPTE_GAPS_EXTREMAUX, DEBUG, PROFILE, COMPTE_GAP_GAP;
extern char NOUVELLE_SEQ, PAS_GAPS_BASE;

extern char pas_d_insertion, pas_de_suppression;

int nbre_lettres, nbre_lettres1, nbre_lettres2;
int *poids, poids_max;


score qngsm(indice i, indice j, char histoire, noeud *n1, noeud *n2, char action)	
{	
lettre *col1, *col2, c1, c2, *colp1, *colp2, cp1, cp2;
int ss, s1, s2;
score scol = 0;	

switch(action)	
   {	
	case REMP:	col1 = coli; col2 = colj;  
			if (n1->noeud1 != NULL)	scol += n1->scol[i];	
			if (n2->noeud1 != NULL)	scol += n2->scol[j];	
			switch(histoire)	
			   {	
				case REMP:	colp1 = colip; colp2 = coljp;  
						break;	
				case SUPP:	colp1 = colip; colp2 = colg;  
						break;	
				case INSE:	colp1 = colg; colp2 = coljp;  
			   }	
			break;	
	case SUPP:	col1 = coli; col2 = colg;  
			if (n1->noeud1 != NULL)	scol += n1->scol[i];
			if (COMPTE_GAP_GAP) scol += (nbseq2*(nbseq2-1)*betaD)/2;
			switch(histoire)	
			   {	
				case REMP:	colp1 = colip; colp2 = colj;  
						break;	
				case SUPP:	colp1 = colip; colp2 = colg;  
						break;	
				case INSE:	colp1 = colg; colp2 = colj;  
			   }	
			break;	
	case INSE:	col1 = colg; col2 = colj;  
			if (n2->noeud1 != NULL)	scol += n2->scol[j];	
			if (COMPTE_GAP_GAP) scol += (nbseq1*(nbseq1-1)*betaD)/2;
			switch(histoire)	
			   {	
				case REMP:	colp1 = coli; colp2 = coljp;  
						break;	
				case SUPP:	colp1 = coli; colp2 = colg;  
						break;	
				case INSE:	colp1 = colg; colp2 = coljp;  
			   }	

   }	


if (COMPTE_GAPS_EXTREMAUX)	
  for (s1=0; s1 < nbseq1; s1++)	
     {	
	c1 = col1[s1]; cp1 = colp1[s1];	
	if (c1 == X)	
	  for (s2=0, ss=nbseq1; s2 < nbseq2; s2++, ss++)	
	     {	
		c2 = col2[s2]; cp2 = colp2[s2];	
		if (c2 != X)	
		    {	
			if (cp1 == X && cp2 != X)	
				scol += betaD;	
			else	
				scol += alphaD;	
		    }	
		else	{ if (COMPTE_GAP_GAP) scol += betaD; }	
	     }	
	else	
	  for (s2=0, ss=nbseq1; s2 < nbseq2; s2++, ss++)	
	     {	
		c2 = col2[s2]; cp2 = colp2[s2];	
		if (c2 == X)	
		     {	
			if (cp1 != X && cp2 == X)	
				scol += betaD;	
			else	
				scol += alphaD;	
		     }	
		else	scol += dis[c1][c2];	
	     }	
     }	
else	
  for (s1=0; s1 < nbseq1; s1++)	
     {	
	c1 = col1[s1]; cp1 = colp1[s1]; 	
	if (c1 == X)	
	  for (s2=0, ss=nbseq1; s2 < nbseq2; s2++, ss++)	
	     {	
		c2 = col2[s2]; cp2 = colp2[s2];	
		if (c2 != X)	
		    {	
			if (i >= n1->premier[s1] && i < n1->dernier[s1])	
			    {
				if (cp1 == X && cp2 != X)	
					scol += betaD;	
				else	
					scol += alphaD;	
			    }
			else		scol += betaD;
		    }	
		else	{ if (COMPTE_GAP_GAP) scol += betaD; }	
	     }	
	else	
	  for (s2=0, ss=nbseq1; s2 < nbseq2; s2++, ss++)	
	     {	
		c2 = col2[s2]; cp2 = colp2[s2];	
		if (c2 == X)	
		     {	
			if (j >= n2->premier[s2] && j < n2->dernier[s2])	
			    {
				if (cp1 != X && cp2 == X)	
					scol += betaD;	
				else	
					scol += alphaD;	
			    }
			else		scol += betaD;
		     }	
		else	scol += dis[c1][c2];	
	     }	
     }	

return(scol);
}	

void generer_gaps(noeud *base, lettre *colonne, int *s)
{

if (base->noeud1 != NULL)
   {
	generer_gaps(base->noeud1, colonne, s);
	generer_gaps(base->noeud2, colonne, s);
   }
else
   {
	colonne[*s] = X;
	(*s)++;
   }
}

void generer_inconnus(noeud *base, lettre *colonne, int *s)
{

if (base->noeud1 != NULL)
   {
	generer_inconnus(base->noeud1, colonne, s);
	generer_inconnus(base->noeud2, colonne, s);
   }
else
   {
	colonne[*s] = INCONNU;
	(*s)++;
   }
}

void generer_colonne_rec(noeud *base, indice i, lettre *colonne, int *s, int *nbl)
{
indice i1, i2;
int x;

if (base->noeud1 != NULL)
   {
	i1 = base->alig[i].i; i2 = base->alig[i].j;
	if (i1 > 0) 	generer_colonne_rec(base->noeud1, i1, colonne, s, nbl);
	else		generer_gaps(base->noeud1, colonne, s);
	if (i2 > 0) 	generer_colonne_rec(base->noeud2, i2, colonne, s, nbl); 
	else		generer_gaps(base->noeud2, colonne, s);
   }
else
   {
	x = base->num;
	colonne[*s] = coder(seq[x].u[i]);

	(*s)++;
	(*nbl)++;
   }
}

void generer_colonne(noeud *base, indice i, lettre *colonne, lettre *colonne_p)
{
int s, nbl;

s = nbl = 0;
generer_colonne_rec(base, i, colonne, &s, &nbl);


if (i > 1)
     {
	s = nbl = 0;
	generer_colonne_rec(base, i-1, colonne_p, &s, &nbl);
     }
else {
	s = 0;
	generer_inconnus(base, colonne_p, &s);
     }

}

int nbre_seq(noeud *base, int s, int *num_seq)
{
if (base->noeud1 != NULL)
   {
	s = nbre_seq(base->noeud1, s, num_seq); 
	s = nbre_seq(base->noeud2, s, num_seq); 
   }
else
   {
	num_seq[s] = base->num;
	s++;
   }

return(s);
}


indice lire_alignement(indice i, indice j, frag *alignement)
{
indice l, k, inter;

l = 1; 
while(i > 0 || j > 0)
	   {
	     	switch(ch[i][j] & ISR)
	           {
			case REM: 
				alignement[l].i = i; alignement[l].j = j; l++;
				i--; j--; 
				break;
			case INS:
				do
				    {
					alignement[l].i = 0; alignement[l].j = j; l++;
					j--; 
				    }
				while (j > 0 && (ch[i][j+1] & F_INS) == 0);
				break;
			case SUP:
				do
				    {
					alignement[l].i = i; alignement[l].j = 0; l++;
					i--;
				    }
				while (i > 0 && (ch[i+1][j] & F_SUP) == 0);
				break;
	    	    }
	    }

l--;

return(l);
}


indice aligne_2noeuds_non_rec(frag *alignement, indice l, noeud *n1, noeud *n2, 
	indice I1, indice J1, char Type1, indice I2, indice J2, char Type2)
{
indice i, j, ip, jp, k, diag, diag0, diag1, diag2, droite, pp_ip_jp, pp_sauv, pp_ins, i1, j1, i2, j2;
indice l_save, r_save, milieu_suiv, milieu_courant;
int s, a, b;
char histoire, histoire_p;
gscore e, d_ip_jp, d_sauv, rempl, insert, suppres, insert_deb, suppres_deb;
score scol;
char type1, type2, type_action, d_egal_e, tpp_ip_jp, tpp_sauv, tpp_ins;


i = I1; j = J1;

diag = I1 + J1;

switch(Type1)
   {
	case REMP:	azero(d[J1]);	type_action = REMP;
			aumax(e); aumax(f[J1]);
			histoire_d[J1] = Type1;

			pp[J1][REMP] = diag;
			tpp[J1][REMP] = REMP;
			histoire_pp_remp[diag] = Type1;
			pp_i[diag] = I1;

			d_egal_e = false;
			break;

	case SUPP:	azero(d[J1]); azero(f[J1]);	type_action = SUPP;
			aumax(e);
			histoire_f[J1] = histoire_d[J1] = Type1;

			pp[J1][REMP] = pp[J1][SUPP] = diag;
			tpp[J1][REMP] = tpp[J1][SUPP] = SUPP;
			histoire_pp_supp[diag] = Type1;
			pp_i[diag] = I1;

			d_egal_e = false;
			break;

	case INSE:	azero(d[J1]); azero(e);	type_action = INSE;
			aumax(f[J1]);
			histoire_e = histoire_d[J1] = Type1;

			pp[J1][REMP] = pp_ins = diag;
			tpp[J1][REMP] = tpp_ins = INSE;
			histoire_pp_inse[diag] = Type1;
			pp_i[diag] = I1;

			d_egal_e = true;
   }

if (I1+1 <= I2) droite = Rr[I1+1];
else		droite = J2;

i = I1;

 
for (j=J1+1; j <= droite; j++)
    {
	generer_colonne(n2, j, colj, coljp);

	diag = i + j;

	ch[i][j] = 0;

	CALCUL_INSERTION

	affecter(d[j], insert);	ch[i][j] |= INS; type_action = INSE;
	histoire_d[j] = histoire_e;
	pp[j][REMP]	= pp_ins;
	tpp[j][REMP]	= tpp_ins;

	aumax(f[j]);

	d_egal_e = true;
   }

for (i=I1+1; i <= I2; i++) 
   {
	generer_colonne(n1, i, coli, colip);

	if (Lr[i] > J1)
	   {
		j = Lr[i] - 1;

		diag = i + j;

		ch[i][j] = 0;

		if (j <= Rr[i])	CALCUL_SUPPRESSION /* normalement toujours vrai ! */
		else {
			aumax(suppres);
		     }

		affecter(d_ip_jp,d[j])
		histoire_d_ip_jp = histoire_d[j];
		pp_ip_jp = pp[j][REMP];
		tpp_ip_jp = tpp[j][REMP];

		affecter(d[j],suppres)	ch[i][j] |= SUP; type_action = SUPP;
		histoire_d[j] = histoire_f[j];
		pp[j][REMP]	= pp[j][SUPP];
		tpp[j][REMP]	= tpp[j][SUPP];

		aumax(e);

		j = Lr[i];
	   }
	else	/* J1 == Lr[i] */
	   {
		j = Lr[i];

		diag = i + j;

		ch[i][j] = 0;

		if (j <= Rr[i])	CALCUL_SUPPRESSION
		else {
			aumax(suppres);
		     }

		affecter(d_ip_jp,d[j])
		histoire_d_ip_jp = histoire_d[j];
		pp_ip_jp = pp[j][REMP];
		tpp_ip_jp = tpp[j][REMP];

		affecter(d[j],suppres)	ch[i][j] |= SUP; type_action = SUPP;
		histoire_d[j] = histoire_f[j];
		pp[j][REMP]	= pp[j][SUPP];
		tpp[j][REMP]	= tpp[j][SUPP];

		aumax(e);

		j = Lr[i]+1;
	   }

	droite = Rr[i];

	d_egal_e = false;


	for (; j <= droite; j++)
	   {
		generer_colonne(n2, j, colj, coljp);

		diag = i + j;

		ch[i][j] = 0;

		if (!contrainte[i])
		    {
			CALCUL_INSERTION
			CALCUL_SUPPRESSION
		    }
		else	{ aumax(insert) aumax(suppres) }

		if (different(d_ip_jp, DISTANCE_ALIG_MAX))
		    {
			scol = qngsm(i, j, histoire_d_ip_jp, n1, n2, REMP);
			ajouter(rempl, d_ip_jp, scol)
		    }
		else	aumax(rempl)


		affecter(d_sauv, d[j])
		histoire_d_sauv = histoire_d[j];
		pp_sauv = pp[j][REMP];
		tpp_sauv = tpp[j][REMP];

		if (inferieuregal(rempl, insert))
		    {
			if (inferieuregal(rempl, suppres))
			   {
				affecter(d[j], rempl)	ch[i][j] |= REM;
				histoire_d[j] = type_action = REMP;

				if (point_de_partition(i, j))
				     {
					succ_pp[diag][REMP] 	= pp_ip_jp;
					succ_tpp[diag][REMP] 	= tpp_ip_jp;
					histoire_pp_remp[diag] = histoire_d[j];
					pp_i[diag] 	= i;
					pp[j][REMP]	= diag;
					tpp[j][REMP] 	= REMP;
				     }
				else {
					pp[j][REMP] 	= pp_ip_jp;
					tpp[j][REMP] 	= tpp_ip_jp;
				     }
			   }
			else
			   {
				affecter(d[j],suppres)	ch[i][j] |= SUP; type_action = SUPP;
				histoire_d[j] = histoire_f[j];

				pp[j][REMP] 	= pp[j][SUPP];
				tpp[j][REMP] 	= tpp[j][SUPP];
			   }
		    }
		else
		    {
			if (inferieuregal(insert, suppres))
			   {
				affecter(d[j], insert);	ch[i][j] |= INS; type_action = INSE;
				histoire_d[j] = histoire_e;

				pp[j][REMP] 	= pp_ins;
				tpp[j][REMP] 	= tpp_ins;
			   }
			else
			   {
				affecter(d[j],suppres)	ch[i][j] |= SUP; type_action = SUPP;
				histoire_d[j] = histoire_f[j];

				pp[j][REMP] 	= pp[j][SUPP];
				tpp[j][REMP] 	= tpp[j][SUPP];
			   }
		    }

		affecter(d_ip_jp, d_sauv)
		histoire_d_ip_jp = histoire_d_sauv;
		pp_ip_jp = pp_sauv;
		tpp_ip_jp = tpp_sauv;
	   }

	if (i+1 <= I2) 	droite = Rr[i+1];
	else		droite = J2;

	d_egal_e = false;

	for (j=Rr[i]+1; j <= droite; j++)
	   {
		generer_colonne(n2, j, colj, coljp);

		diag = i + j;

		ch[i][j] = 0;

		CALCUL_INSERTION

		affecter(d[j], insert);	ch[i][j] |= INS; type_action = INSE;
		histoire_d[j] = histoire_e;
		pp[j][REMP]	= pp_ins;
		tpp[j][REMP]	= tpp_ins;

		aumax(f[j]);

		d_egal_e = true;
	   }
   }

/*if (n1->num == 5 && n2->num == 2)
 {
	for (i=1, printf("\n%3d ", i); i <= I2; i++, printf("\n%3d ", i))
	    {
 	 	for (j=1; j <= J2; j++)
	   	{
		switch(ch[i][j] & ISR)
		  {
		case REM:	printf("\\");
				break;
		case INS:	printf("-");
				break;
		case SUP:	printf("|");
		  }
	  	}

	    }
	printf("\n\n");
	for (i=1, printf("\n%3d ", i); i <= I2; i++, printf("\n%3d ", i))
	    {
 	 	for (j=1; j <= J2; j++)
	   	{
		if ((ch[i][j] & F_INS) == 0) 	printf("-");
		else				printf(" ");
	  	}
	    }
  }*/

l = lire_alignement(I2, J2, alignement);

/*for (k=1; k<=l; k++)
printf("{%d,%d}\n", alignement[k].i, alignement[k].j);*/

return(l);
}


indice aligne_2noeuds_rec(frag *alignement, indice l, noeud *n1, noeud *n2, 
	indice I1, indice J1, char Type1, indice I2, indice J2, char Type2)
{
indice i, j, ip, jp, k, diag, diag0, diag1, diag2, droite, pp_ip_jp, pp_sauv, pp_ins, i1, j1, i2, j2;
indice l_save, r_save, milieu_suiv, milieu_courant;
int s, a, b;
char histoire, histoire_p;
gscore e, d_ip_jp, d_sauv, rempl, insert, suppres, insert_deb, suppres_deb;
score scol;
char type1, type2, type_action, d_egal_e, tpp_ip_jp, tpp_sauv, tpp_ins;


diag = I1 + J1;

switch(Type1)
   {
	case REMP:	azero(d[J1]);	type_action = REMP;
			aumax(e); aumax(f[J1]);
			histoire_d[J1] = Type1;

			pp[J1][REMP] = diag;
			tpp[J1][REMP] = REMP;
			histoire_pp_remp[diag] = Type1;
			pp_i[diag] = I1;

			d_egal_e = false;
			break;

	case SUPP:	azero(d[J1]); azero(f[J1]);	type_action = SUPP;
			aumax(e);
			histoire_f[J1] = histoire_d[J1] = Type1;

			pp[J1][REMP] = pp[J1][SUPP] = diag;
			tpp[J1][REMP] = tpp[J1][SUPP] = SUPP;
			histoire_pp_supp[diag] = Type1;
			pp_i[diag] = I1;

			d_egal_e = false;
			break;

	case INSE:	azero(d[J1]); azero(e);	type_action = INSE;
			aumax(f[J1]);
			histoire_e = histoire_d[J1] = Type1;

			pp[J1][REMP] = pp_ins = diag;
			tpp[J1][REMP] = tpp_ins = INSE;
			histoire_pp_inse[diag] = Type1;
			pp_i[diag] = I1;

			d_egal_e = true;
   }

if (I1+1 <= I2) droite = Rr[I1+1];
else		droite = J2;

i = I1;

for (j=J1+1; j <= droite; j++)
    {
	generer_colonne(n2, j, colj, coljp);

	diag = i + j;

	CALCUL_INSERTION

	affecter(d[j], insert);	type_action = INSE;
	histoire_d[j] = histoire_e;
	pp[j][REMP]	= pp_ins;
	tpp[j][REMP]	= tpp_ins;

	aumax(f[j]);

	d_egal_e = true;
   }

for (i=I1+1; i <= I2; i++) 
   {
	generer_colonne(n1, i, coli, colip);

	if (Lr[i] > J1)
	   {
		j = Lr[i] - 1;

		diag = i + j;

		if (j <= Rr[i])	CALCUL_SUPPRESSION /* normalement toujours vrai ! */
		else {
			aumax(suppres);
		     }

		affecter(d_ip_jp, d[j])
		histoire_d_ip_jp = histoire_d[j];
		pp_ip_jp = pp[j][REMP];
		tpp_ip_jp = tpp[j][REMP];

		affecter(d[j], suppres)	type_action = SUPP;
		histoire_d[j] = histoire_f[j];
		pp[j][REMP]	= pp[j][SUPP];
		tpp[j][REMP]	= tpp[j][SUPP];

		aumax(e)

		j = Lr[i];
	   }
	else	/* J1 == Lr[i] */
	   {
		j = Lr[i];

		diag = i + j;

		if (j <= Rr[i])	CALCUL_SUPPRESSION
		else {
			aumax(suppres);
		     }

		affecter(d_ip_jp,d[j])
		histoire_d_ip_jp = histoire_d[j];
		pp_ip_jp = pp[j][REMP];
		tpp_ip_jp = tpp[j][REMP];

		affecter(d[j], suppres)	type_action = SUPP;
		histoire_d[j] = histoire_f[j];
		pp[j][REMP]	= pp[j][SUPP];
		tpp[j][REMP]	= tpp[j][SUPP];

		aumax(e)

		j = Lr[i]+1;
	   }

	droite = Rr[i];

	d_egal_e = false;

	for (; j <= droite; j++)
	   {
		generer_colonne(n2, j, colj, coljp);

		diag = i + j;

		if (!contrainte[i])
		    {
			CALCUL_INSERTION
			CALCUL_SUPPRESSION
		    }
		else	{ aumax(insert) aumax(suppres) }

		if (different(d_ip_jp, DISTANCE_ALIG_MAX))
		    {
			scol = qngsm(i, j, histoire_d_ip_jp, n1, n2, REMP);
			ajouter(rempl, d_ip_jp, scol)
		    }
		else	aumax(rempl)

		affecter(d_sauv, d[j])
		histoire_d_sauv = histoire_d[j];
		pp_sauv = pp[j][REMP];
		tpp_sauv = tpp[j][REMP];

/*if (n1->num == 22 && n2->num == 16 && i == 1498)
printf("i=%d, s=%d, r=%d\n", insert.b, suppres.b, rempl.b);*/

		if (inferieuregal(rempl, insert))
		    {
			if (inferieuregal(rempl, suppres))
			   {
				affecter(d[j], rempl)	
				histoire_d[j] = type_action = REMP;

				if (point_de_partition(i, j))
				     {
					succ_pp[diag][REMP] 	= pp_ip_jp;
					succ_tpp[diag][REMP] 	= tpp_ip_jp;
					histoire_pp_remp[diag] = histoire_d[j];
					pp_i[diag] 	= i;
					pp[j][REMP]	= diag;
					tpp[j][REMP] 	= REMP;
				     }
				else {
					pp[j][REMP] 	= pp_ip_jp;
					tpp[j][REMP] 	= tpp_ip_jp;
				     }
			   }
			else
			   {
				affecter(d[j],suppres)	type_action = SUPP;
				histoire_d[j] = histoire_f[j];

				pp[j][REMP] 	= pp[j][SUPP];
				tpp[j][REMP] 	= tpp[j][SUPP];
			   }
		    }
		else
		    {
			if (inferieuregal(insert, suppres))
			   {
				affecter(d[j], insert)	type_action = INSE;
				histoire_d[j] = histoire_e;

				pp[j][REMP] 	= pp_ins;
				tpp[j][REMP] 	= tpp_ins;
			   }
			else
			   {
				affecter(d[j],suppres)	type_action = SUPP;
				histoire_d[j] = histoire_f[j];

				pp[j][REMP] 	= pp[j][SUPP];
				tpp[j][REMP] 	= tpp[j][SUPP];
			   }
		    }

		affecter(d_ip_jp, d_sauv)
		histoire_d_ip_jp = histoire_d_sauv;
		pp_ip_jp = pp_sauv;
		tpp_ip_jp = tpp_sauv;
	   }

	if (i+1 <= I2) 	droite = Rr[i+1];
	else		droite = J2;

	d_egal_e = false;

	for (j=Rr[i]+1; j <= droite; j++)
	   {
		generer_colonne(n2, j, colj, coljp);

		diag = i + j;

		CALCUL_INSERTION

		affecter(d[j], insert)	type_action = INSE;
		histoire_d[j] = histoire_e;
		pp[j][REMP]	= pp_ins;
		tpp[j][REMP]	= tpp_ins;

		aumax(f[j])

		d_egal_e = true;
	   }
    }

if (I2 == n1->longueur && J2 == n2->longueur)
   {
	Type2 = type_action;
	if (!point_de_partition(I2,J2))
	    {
		succ_pp[I2+J2][Type2] 	= pp[J2][REMP];
		succ_tpp[I2+J2][Type2] 	= tpp[J2][REMP];
	    }
   }

diag0 = I1 + J1;
i2 = I2; j2 = J2;
type2 = Type2;
diag2 = I2 + J2;

while (diag2 != diag0)
    {
	diag1 = succ_pp[diag2][type2];
	type1 = succ_tpp[diag2][type2];
	i1 = pp_i[diag1];
	j1 = diag1 - i1;

	if (i1 == i2)
	     {
		if (j2 > j1)
		   for (j=j2; j > j1; j--)
			INSERTION(j)
	     }
	else {
		if (j1 == j2)
		    for (i=i2; i > i1; i--)
			SUPPRESSION(i)
		else {
			if (i1+1 == i2 && j1+1 == j2) 
			     {
				if (type2 == REMP)	REMPLACEMENT(i2, j2)
				else {
					if (type2 == INSE)
					     {
						INSERTION(j2)
						SUPPRESSION(i2)
					     }
					else {
						SUPPRESSION(i2)
						INSERTION(j2)
				     	     }
				     }
			     }
			else {
				l_save = Lr[i1];
				r_save = Rr[i1];

				if (j1 < milieu(i1)) /* probleme gauche */
				     {
					for (i = i2; i > i1; i--) 
					   {
						milieu_suiv = milieu(i-1);
						Lr[i] = max(j1, Lr[i]);
						Rr[i] = milieu_suiv - 1;
					   }
					Lr[i1] = j1;
					Rr[i1] = j1;
					Rr[i2] = j2;
				     } 
				else {	/* probleme droit */
					for (i = i1; i < i2; i++) 
					    {
						milieu_courant = milieu(i);
						Lr[i] = max(milieu_courant, L_ip1_m1(i)) + 1;
						Rr[i] = min(j2, Rr[i]);
					    }
					Lr[i1] = j1;
					Lr[i2] = j2;
					Rr[i2] = j2;
				     }

				l = aligne_2noeuds_rec(alignement, l, n1, n2, 
					i1, j1, type1, i2, j2, type2);

				Lr[i1] = l_save;
				Rr[i1] = r_save;
			     }
		     }
	     }

	i2 = i1;
	j2 = j1;
	type2 = type1;
	diag2 = diag1;
    }


return(l);
}

void aligne_2noeuds(noeud *n0, noeud *n1, noeud *n2, int *poids_, int poids_max_)
{
indice i, j, ip, jp, k, inter, l, n, p;
int ss, s1, s2, s, a, b, x;
indice nprec, nsuiv;
char histoire, histoire_p;
score scol, salig, vsalig;
char action, action_p;

frag *alignement;

poids = poids_;
poids_max = poids_max_;

alignement = n0->alig;

a = n1->num;
b = n2->num;
nbseq1 = nbre_seq(n1, 0, num_seq1);
nbseq2 = nbre_seq(n2, 0, num_seq2);
nbseq = nbseq1 + nbseq2;


if (DEBUG)
   {
	printf("numero des sequences du noeud1: ");
	for (s=0; s < nbseq1; s++)	printf("(%d,%d)", s, num_seq1[s]);
	printf("\nnumero des sequences du noeud2: ");
	for (s=0; s < nbseq2; s++)	printf("(%d,%d)", s, num_seq2[s]);
	printf("\n");
   }

nprec = 0; 
for (i=1; i < n1->longueur && seq[a].ech[i] == 0; i++);
nsuiv = seq[a].ech[i];

for(i=1; i <= n1->longueur; i++)
     {
	if (seq[a].ech[i] > 0)
	    {
		nprec = nsuiv = seq[a].ech[i];
	    }
	else if (i > 1 && seq[a].ech[i-1] > 0)
		    {
			for (k = i; k < n1->longueur && seq[a].ech[k] == 0; k++);
			nsuiv = seq[a].ech[k];
		    }

	if (seq[a].ech[i] > 0 && ech[nprec].ind[b] > 0) 
	   {	/* (n1, i) correspond \`a un (n2, j) */

		Lr[i] = Rr[i] = ech[nprec].ind[b];

		contrainte[i] = true;
	   }
	else
	   {
	     	if (nprec == 0) Lr[i] = 1;
	     	else		Lr[i] = seuil_g[nprec][b] + 1;
	     	if (nsuiv == 0) Rr[i] = n2->longueur;
	     	else		Rr[i] = seuil_d[nsuiv][b] - 1;

		contrainte[i] = false;
	   }
     }


l = Lr[0] = Rr[0] = 0;


pas_d_insertion = pas_de_suppression = false;

if (NOUVELLE_SEQ && PAS_GAPS_BASE)
   {
	for (s=0; s < nbseq1-1 && num_seq1[s] != 0; s++);
	if (num_seq1[s] == 0)	pas_d_insertion = true;
	else {
		for (s=0; s < nbseq2-1 && num_seq2[s] != 0; s++);
		if (num_seq2[s] == 0)	pas_de_suppression = true;
	     }
   }

if (RECURSIF)
	l = aligne_2noeuds_rec(alignement, l, n1, n2, 0, 0, REMP,  
					n1->longueur, n2->longueur, REMP);
else
	l = aligne_2noeuds_non_rec(alignement, l, n1, n2, 0, 0, REMP,  
					n1->longueur, n2->longueur, REMP);


if (DEBUG) printf("alignement de longueur %d (%d)\n", l, alignement);

for (k=1; k <= l/2; k++)
   {
	inter = alignement[k].i;
	alignement[k].i = alignement[l-k+1].i;
	alignement[l-k+1].i = inter;

	inter = alignement[k].j;
	alignement[k].j = alignement[l-k+1].j;
	alignement[l-k+1].j = inter;
   }

ip = jp = i = j = 0;
 

if (DEBUG) printf("avant allocation (n0=%d)\n", n0);

n0->premier = (int *) allouer(nbseq*sizeof(int));
n0->dernier = (int *) allouer(nbseq*sizeof(int));
n0->scol = (score *) allouer((l+1)*sizeof(score));

if (DEBUG) printf("apres allocation\n");

salig = vsalig = 0;

action_p = REMP;

for (k=1; k <= l; k++)
   {
	action = REMP;

	if (alignement[k].i != 0)
	    {
		i = alignement[k].i;
		generer_colonne(n1, i, coli, colip);
		if (!COMPTE_GAPS_EXTREMAUX)
		     {
			for (s1=0; s1 < nbseq1; s1++)
			    if (coli[s1] != X)
			     {
				if (i == n1->premier[s1])		n0->premier[s1] = k;
				else { if (i == n1->dernier[s1])	n0->dernier[s1] = k; }
			     }
		     }
	    }
	else	action = INSE;

	if (alignement[k].j != 0)
	    {
		j = alignement[k].j;
		generer_colonne(n2, j, colj, coljp);
		if (!COMPTE_GAPS_EXTREMAUX)
		     {
		  	for (s2=0, ss=nbseq1; s2 < nbseq2; s2++, ss++)
		    	   if (colj[s2] != X)
			     {
				if (j == n2->premier[s2])		n0->premier[ss] = k;
				else { if (j == n2->dernier[s2])	n0->dernier[ss] = k; }
			     }
		     }
	    }
	else	action = SUPP;


	scol = qngsm(i, j, action_p, n1, n2, action);

	n0->scol[k] = scol;

	action_p = action;
	ip = i; jp = j;
   }



n0->longueur = l; 
}
