#include <math.h>
#include <stdlib.h>
#include <stdio.h>
 
#include "greedy.h"

#define L_i_m1(i_) 	(max(Lr[i_]-1, J1))
#define R_ip1(i_) 	((i_==I2) ? J2 : Rr[(i_)+1])
#define milieu(i_)	((L_i_m1(i_) + R_ip1(i_) + 1) / 2)
#define m_im1(i_) 	((i_==I1) ? J1 : milieu((i_)-1))
#define L_ip1_m1(i_) 	((i_==I2) ? J2 : L_i_m1((i_)+1))
#define point_de_partition(i_, j_) ((j_ <= milieu(i_)) ? (j_ >= max(L_i_m1(i_), m_im1(i_))) : (j_ <= min(L_ip1_m1(i_), R_ip1(i_))))

#define azero_P(element)	{element.b = element.h = element.l = 0; }
#define aumin_P(element)	element.b = SCORE_MIN.h;
#define affecter_P(element1, element2)	{element1.b = element2.b; \
						element1.h = element2.h; \
						element1.l = element2.l; }
#define different_P(element1, element2)	(element1.b != element2.b)
#define ssuperieur_P(element1, element2)	(element1.b > element2.b)
#define superieuregal_P(element1, element2)	(element1.b >= element2.b)
#define ajouter_P(resultat, objet, pscore)	{resultat.b = objet.b + pscore;	\
						resultat.h = objet.h; \
						resultat.l = objet.l; } 
#define qngsm_inse(histoire)	\
(COMPTE_GAPS_EXTREMAUX?	((histoire==INSE)? betaS : alphaS) : \
	((i >= 0 && i < longueur_a) ? (histoire==INSE ? betaS : alphaS) : betaS))

#define qngsm_supp(histoire)	\
(COMPTE_GAPS_EXTREMAUX?	((histoire==SUPP)? betaS : alphaS) : \
	((j >= 0 && j < longueur_b) ? (histoire==SUPP ? betaS : alphaS) : betaS))


#define CALCUL_P_INSERTION \
   {	\
	if (different_P(e, SCORE_MIN))	\
		ajouter_P(insert, e, qngsm_inse(histoire_e))	\
	else	aumin_P(insert)	\
	if (d_egal_e) 	affecter_P(insert_deb, insert)	\
	else {	\
		if (different_P(d[j-1], SCORE_MIN))	\
			ajouter_P(insert_deb, d[j-1], qngsm_inse(histoire_d[j-1]))	\
		else	aumin_P(insert_deb) \
	     }	\
	if (ssuperieur_P(insert_deb, insert))	\
	     {	\
		if (!RECURSIF)	ch[i][j] |= F_INS;	\
		affecter_P(insert, insert_deb)	\
		histoire_e = INSE;	\
		if (point_de_partition(i, j))	\
		     {	\
			succ_pp[diag][INSE] 	= pp[j-1][REMP];	\
			succ_tpp[diag][INSE] 	= tpp[j-1][REMP];	\
			histoire_pp_inse[diag] = histoire_e;	\
			pp_i[diag] 	= i;	\
			pp_ins 		= diag;	\
			tpp_ins 	= INSE;	\
		     }	\
		else {	\
			pp_ins 		= pp[j-1][REMP];	\
			tpp_ins 	= tpp[j-1][REMP];	\
		     }	\
	     }	\
	else {	\
		histoire_e = INSE;	\
		if (point_de_partition(i, j))	\
		     {	\
			succ_pp[diag][INSE] 	= pp_ins;	\
			succ_tpp[diag][INSE] 	= tpp_ins;	\
			histoire_pp_inse[diag] = histoire_e;	\
			pp_i[diag] 	= i;	\
			pp_ins 		= diag;	\
			tpp_ins 	= INSE;	\
		     }	\
	     }	\
	affecter_P(e, insert)	\
   }

#define CALCUL_P_SUPPRESSION	\
    {	\
	if (different_P(f[j], SCORE_MIN))	\
		ajouter_P(suppres, f[j], qngsm_supp(histoire_f[j]))	\
	else	aumin_P(suppres);	\
	if (different_P(d[j], SCORE_MIN))	\
		ajouter_P(suppres_deb, d[j], qngsm_supp(histoire_d[j]))	\
	else	aumin_P(suppres_deb)	\
	if (ssuperieur_P(suppres_deb, suppres))	\
	     {	\
		if (!RECURSIF)	ch[i][j] |= F_SUP;	\
		affecter_P(suppres, suppres_deb)	\
		histoire_f[j] = SUPP;	\
		if (point_de_partition(i, j))	\
		     {	\
			succ_pp[diag][SUPP] 	= pp[j][REMP];	\
			succ_tpp[diag][SUPP] 	= tpp[j][REMP];	\
			histoire_pp_supp[diag] = histoire_f[j];	\
			pp_i[diag] 	= i;	\
			pp[j][SUPP]	= diag;	\
			tpp[j][SUPP] 	= SUPP;	\
		     }	\
		else {	\
			pp[j][SUPP] 	= pp[j][REMP];	\
			tpp[j][SUPP] 	= tpp[j][REMP];	\
		     }	\
	     }	\
	else {	\
		histoire_f[j] = SUPP;	\
		if (point_de_partition(i, j))	\
		     {	\
			succ_pp[diag][SUPP] 	= pp[j][SUPP];	\
			succ_tpp[diag][SUPP] 	= tpp[j][SUPP];	\
			histoire_pp_supp[diag] = histoire_f[j];	\
			pp_i[diag] 	= i;	\
			pp[j][SUPP] 	= diag;	\
			tpp[j][SUPP] 	= SUPP;	\
		     }	\
	     }	\
	affecter_P(f[j], suppres)	\
   }

#define generer_colonne_a_P	{ ca = coder(seq[a].u[i]); }
#define generer_colonne_b_P	{ cb = coder(seq[b].u[j]); }

score score_paire_seq(noeud *n1, noeud *n2);
score score_remplacement(noeud *n1, noeud *n2);

extern sequence *seq;
extern int NBRE_LETTRES, X, INCONNU;
extern score alphaS, betaS;
extern echelle *ech;
extern indice **seuil_g, **seuil_d;

extern int NBRE_LETTRES,  R;
extern score **sim;

extern lettre *coli, *colj, *colip, *coljp, *colg;
extern int *num_seq1, *num_seq2;
extern int  nbseq1, nbseq2, nbseq;

extern gscore *d, *f;
extern gscore SCORE_MIN;

extern char *histoire_d, *histoire_f, histoire_e;
extern char histoire_d_ip_jp, histoire_d_sauv;
extern char *histoire_pp_remp, *histoire_pp_supp, *histoire_pp_inse;

extern int (*pp)[2], (*succ_pp)[3], *pp_i, *Rr, *Lr;
extern char (*tpp)[2], (*succ_tpp)[3], *contrainte;

extern char **ch;
extern score **dist_entre_seq;
extern char RECURSIF;
extern char decode[100];
extern lettre code[128];

extern char COMPTE_GAPS_EXTREMAUX, DEBUG, PROFILE, COMPTE_GAP_GAP;
extern char NOUVELLE_SEQ, PAS_GAPS_BASE;

extern char pas_d_insertion, pas_de_suppression;

score score_paire_seq(noeud *n1, noeud *n2)
{
indice i, j, ip, jp, k, diag, diag0, diag1, diag2, droite, pp_ip_jp, pp_sauv, pp_ins, i1, j1, i2, j2;
indice l_save, r_save, milieu_suiv, milieu_courant;
int s, a, b;
char histoire, histoire_p;
gscore e, d_ip_jp, d_sauv, rempl, insert, suppres, insert_deb, suppres_deb;
score scol;
char type1, type2, d_egal_e, tpp_ip_jp, tpp_sauv, tpp_ins;
indice I1, J1, I2, J2, longueur_a, longueur_b;
indice nprec, nsuiv;
lettre ca, cb;

pas_d_insertion = pas_de_suppression = false;

a = n1->num;
b = n2->num;

longueur_a = seq[a].longueur;
longueur_b = seq[b].longueur;

I1 = J1 = 0;
I2 = longueur_a;
J2 = longueur_b;

nprec = 0; 
for (i=1; i < longueur_a && seq[a].ech[i] == 0; i++);
nsuiv = seq[a].ech[i];

for(i=1; i <= longueur_a; i++)
     {
	if (seq[a].ech[i] > 0)
	    {
		nprec = nsuiv = seq[a].ech[i];
	    }
	else if (i > 1 && seq[a].ech[i-1] > 0)
		    {
			for (k = i; k < longueur_a && seq[a].ech[k] == 0; k++);
			nsuiv = seq[a].ech[k];
		    }

	if (seq[a].ech[i] > 0 && ech[nprec].ind[b] > 0) 
	   {	/* (n1, i) correspond \`a un (n2, j) */

		Lr[i] = Rr[i] = ech[nprec].ind[b];

		contrainte[i] = true;
	   }
	else
	   {
	     	if (nprec == 0) Lr[i] = 1;
	     	else		Lr[i] = seuil_g[nprec][b] + 1;
	     	if (nsuiv == 0) Rr[i] = longueur_b;
	     	else		Rr[i] = seuil_d[nsuiv][b] - 1;

		contrainte[i] = false;
	   }
     }


Lr[0] = Rr[0] = 0;

diag = I1 + J1;

azero_P(d[J1]);	histoire_d[J1] = REMP;
aumin_P(e); aumin_P(f[J1]);

d_egal_e = false;

if (I1+1 <= I2) droite = Rr[I1+1];
else		droite = J2;

i = I1;

 

for (j=J1+1; j <= droite; j++)
    {
	generer_colonne_b_P;

	diag = i + j;

	CALCUL_P_INSERTION

	affecter_P(d[j], insert);	
	histoire_d[j] = histoire_e;

	aumin_P(f[j]);

	d_egal_e = true;
   }


for (i=I1+1; i <= I2; i++) 
   {
	generer_colonne_a_P;

	if (Lr[i] > J1)
	   {
		j = Lr[i] - 1;

		diag = i + j;

		if (j <= Rr[i])	CALCUL_P_SUPPRESSION /* normalement toujours vrai ! */
		else {
			aumin_P(suppres);
		     }

		affecter_P(d_ip_jp,d[j])
		histoire_d_ip_jp = histoire_d[j];

		affecter_P(d[j],suppres)	
		histoire_d[j] = histoire_f[j];

		aumin_P(e);

		j = Lr[i];
	   }
	else	/* J1 == Lr[i] */
	   {
		j = Lr[i];

		diag = i + j;

		if (j <= Rr[i])	CALCUL_P_SUPPRESSION
		else {
			aumin_P(suppres);
		     }

		affecter_P(d_ip_jp,d[j])
		histoire_d_ip_jp = histoire_d[j];

		affecter_P(d[j],suppres)	
		histoire_d[j] = histoire_f[j];

		aumin_P(e);

		j = Lr[i]+1;
	   }

	droite = Rr[i];

	d_egal_e = false;

	for (; j <= droite; j++)
	   {
		generer_colonne_b_P;

		diag = i + j;

		if (!contrainte[i])
		    {
			CALCUL_P_INSERTION
			CALCUL_P_SUPPRESSION
		    }
		else	{ aumin_P(insert) aumin_P(suppres) }

		if (different_P(d_ip_jp, SCORE_MIN))
			ajouter_P(rempl, d_ip_jp, sim[ca][cb])
		else	aumin_P(rempl)

		affecter_P(d_sauv, d[j])
		histoire_d_sauv = histoire_d[j];

		if (superieuregal_P(rempl, insert))
		    {
			if (superieuregal_P(rempl, suppres))
			   {
				affecter_P(d[j], rempl)
				histoire_d[j] = REMP;
			   }
			else
			   {
				affecter_P(d[j],suppres)	
				histoire_d[j] = histoire_f[j];
			   }
		    }
		else
		    {
			if (superieuregal_P(insert, suppres))
			   {
				affecter_P(d[j], insert);	
				histoire_d[j] = histoire_e;
			   }
			else
			   {
				affecter_P(d[j],suppres)	
				histoire_d[j] = histoire_f[j];
			   }
		    }

		affecter_P(d_ip_jp, d_sauv)
		histoire_d_ip_jp = histoire_d_sauv;


	   }

	if (i+1 <= I2) 	droite = Rr[i+1];
	else		droite = J2;

	d_egal_e = false;

	for (j=Rr[i]+1; j <= droite; j++)
	   {
		generer_colonne_b_P;

		diag = i + j;

		CALCUL_P_INSERTION

		affecter_P(d[j], insert);	
		histoire_d[j] = histoire_e;

		aumin_P(f[j]);

		d_egal_e = true;
	   }
   }

return(d[J2].b);
}


score score_remplacement(noeud *n1, noeud *n2)
{
indice i, j, ip, jp, k, diag, diag0, diag1, diag2, droite, pp_ip_jp, pp_sauv, pp_ins, i1, j1, i2, j2;
indice l_save, r_save, milieu_suiv, milieu_courant;
int s, a, b;
char histoire, histoire_p;
gscore e, d_ip_jp, d_sauv, rempl, insert, suppres, insert_deb, suppres_deb;
score scol;
char type1, type2, d_egal_e, tpp_ip_jp, tpp_sauv, tpp_ins;
indice I1, J1, I2, J2, longueur_a, longueur_b;
indice nprec, nsuiv;
lettre ca, cb;

pas_d_insertion = pas_de_suppression = false;

a = n1->num;
b = n2->num;

longueur_a = seq[a].longueur;
longueur_b = seq[b].longueur;

I1 = J1 = 0;
I2 = longueur_a;
J2 = longueur_b;

nprec = 0; 
for (i=1; i < longueur_a && seq[a].ech[i] == 0; i++);
nsuiv = seq[a].ech[i];

for(i=1; i <= longueur_a; i++)
     {
	if (seq[a].ech[i] > 0)
	    {
		nprec = nsuiv = seq[a].ech[i];
	    }
	else if (i > 1 && seq[a].ech[i-1] > 0)
		    {
			for (k = i; k < longueur_a && seq[a].ech[k] == 0; k++);
			nsuiv = seq[a].ech[k];
		    }

	if (seq[a].ech[i] > 0 && ech[nprec].ind[b] > 0) 
	   {	/* (n1, i) correspond \`a un (n2, j) */

		Lr[i] = Rr[i] = ech[nprec].ind[b];

		contrainte[i] = true;
	   }
	else
	   {
	     	if (nprec == 0) Lr[i] = 1;
	     	else		Lr[i] = seuil_g[nprec][b] + 1;
	     	if (nsuiv == 0) Rr[i] = longueur_b;
	     	else		Rr[i] = seuil_d[nsuiv][b] - 1;

		contrainte[i] = false;
	   }
     }


Lr[0] = Rr[0] = 0;

diag = I1 + J1;

azero_P(d[J1]);	histoire_d[J1] = REMP;
aumin_P(e); aumin_P(f[J1]);

d_egal_e = false;

if (I1+1 <= I2) droite = Rr[I1+1];
else		droite = J2;

i = I1;

 

for (j=J1+1; j <= droite; j++)
    {
	generer_colonne_b_P;

	diag = i + j;

	CALCUL_P_INSERTION

	affecter_P(d[j], insert);	
	histoire_d[j] = histoire_e;

	aumin_P(f[j]);

	d_egal_e = true;
   }


for (i=I1+1; i <= I2; i++) 
   {
	generer_colonne_a_P;

	if (Lr[i] > J1)
	   {
		j = Lr[i] - 1;

		diag = i + j;

		if (j <= Rr[i])	CALCUL_P_SUPPRESSION /* normalement toujours vrai ! */
		else {
			aumin_P(suppres);
		     }

		affecter_P(d_ip_jp,d[j])
		histoire_d_ip_jp = histoire_d[j];

		affecter_P(d[j],suppres)	
		histoire_d[j] = histoire_f[j];

		aumin_P(e);

		j = Lr[i];
	   }
	else	/* J1 == Lr[i] */
	   {
		j = Lr[i];

		diag = i + j;

		if (j <= Rr[i])	CALCUL_P_SUPPRESSION
		else {
			aumin_P(suppres);
		     }

		affecter_P(d_ip_jp,d[j])
		histoire_d_ip_jp = histoire_d[j];

		affecter_P(d[j],suppres)	
		histoire_d[j] = histoire_f[j];

		aumin_P(e);

		j = Lr[i]+1;
	   }

	droite = Rr[i];

	d_egal_e = false;

	for (; j <= droite; j++)
	   {
		generer_colonne_b_P;

		diag = i + j;

		if (!contrainte[i])
		    {
			CALCUL_P_INSERTION
			CALCUL_P_SUPPRESSION
		    }
		else	{ aumin_P(insert) aumin_P(suppres) }

		if (different_P(d_ip_jp, SCORE_MIN))
			ajouter_P(rempl, d_ip_jp, sim[ca][cb])
		else	aumin_P(rempl)

		affecter_P(d_sauv, d[j])
		histoire_d_sauv = histoire_d[j];

		if (superieuregal_P(rempl, insert))
		    {
			if (superieuregal_P(rempl, suppres))
			   {
				affecter_P(d[j], rempl)
				histoire_d[j] = REMP;
				d[j].l++;
				d[j].h +=  /*((ca!=cb)?1:0);*/ sim[ca][cb];
			   }
			else
			   {
				affecter_P(d[j],suppres)	
				histoire_d[j] = histoire_f[j];
			   }
		    }
		else
		    {
			if (superieuregal_P(insert, suppres))
			   {
				affecter_P(d[j], insert);	
				histoire_d[j] = histoire_e;
			   }
			else
			   {
				affecter_P(d[j],suppres)	
				histoire_d[j] = histoire_f[j];
			   }
		    }

		affecter_P(d_ip_jp, d_sauv)
		histoire_d_ip_jp = histoire_d_sauv;


	   }

	if (i+1 <= I2) 	droite = Rr[i+1];
	else		droite = J2;

	d_egal_e = false;

	for (j=Rr[i]+1; j <= droite; j++)
	   {
		generer_colonne_b_P;

		diag = i + j;

		CALCUL_P_INSERTION

		affecter_P(d[j], insert);	
		histoire_d[j] = histoire_e;

		aumin_P(f[j]);

		d_egal_e = true;
	   }
   }

return((d[J2].h*10000)/d[J2].l);
}


