#include <stdio.h>
#include <stdlib.h>

void greedy(int argc, char **argv);
void *allouer(size_t taille);
void *reallouer(void *pointeur, size_t taille);
void liberer(void *pointeur);

extern char DEBUG;

void mess_erreur(char *message);

void *allouer(size_t taille)
{
void *pointeur;


if (taille == 0)	taille = 1;

pointeur = (void *) malloc(taille);

if (pointeur==NULL)
    {
	if (DEBUG)	printf("Erreur: %d octets demandes dans malloc\n", taille);
	mess_erreur("Error: out of memory");
    }
else	return(pointeur);
}

void *reallouer(void *pointeur, size_t taille)
{
void *p;

p = pointeur;


pointeur = (void *) realloc(pointeur, taille);


if (pointeur==NULL)
    {
	if (DEBUG)	printf("Erreur: %d octets demandes dans realloc\n", taille);
	mess_erreur("Error: out of memory");
    }
else	return(pointeur);
}

void liberer(void *pointeur)
{

free(pointeur);
}

void mess_erreur(char *message)
{

printf("%s\n", message);

}

 
main(int argc, char **argv)
{
int i;
FILE *f;

greedy(argc, argv);

exit(0);
}
